﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;
using Windows.Media.SpeechRecognition;

namespace PpapCollage
{
    /// <summary>
    /// MainWindow.xaml の相互作用ロジック
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        protected MainViewModel ViewModel => this.DataContext as MainViewModel;
        private DispatcherTimer _timer;

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            this.ViewModel.Initialize();

            _timer = new DispatcherTimer(
               new TimeSpan(TimeSpan.TicksPerSecond / 60), // 60fpsくらい出したい
               DispatcherPriority.Render,
               (_, __) =>
               {
                   var duration = mediaElement.NaturalDuration;
                    // まだロードできてない
                    if (!duration.HasTimeSpan) return;

                   this.ViewModel.Update(
                       mediaElement.Position,
                       canvas.ActualWidth,
                       canvas.ActualHeight
                   );
               },
               this.Dispatcher
           );
        }
    }
}
